Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_FILE_IO Class Reference

Read/Write operations on Files. More...

`#include <FILE_IO.h>`

Inheritance diagram for ACE_FILE_IO

[legend]
Collaboration diagram for ACE_FILE_IO:

[legend]
List of all members.

## Public Types
typedef ACE_FILE_Addr | PEER_ADDR
## Public Methods
| ACE_FILE_IO (void)
| Default constructor.
ssize_t | send (const void *buf, size_t n) const
| send upto <n> bytes in <buf>.
ssize_t | recv (void *buf, size_t n) const
| Recv upto <n> bytes in <buf>.
ssize_t | send_n (const void *buf, size_t n) const
| Send n bytes, keep trying until n are sent.
ssize_t | send_n (const ACE_Message_Block *message_block, const ACE_Time_Value *timeout = 0, size_t *bytes_transferred = 0)
| Send all the <message_block>s chained through their <next> and <cont> pointers. This call uses the underlying OS gather-write operation to reduce the domain-crossing penalty.
ssize_t | recv_n (void *buf, size_t n) const
| Recv n bytes, keep trying until n are received.
ssize_t | send (const iovec iov[], size_t n) const
| Send iovecs via <writev>.
ssize_t | recv (iovec iov[], size_t n) const
| Recv iovecs via <readv>.
ssize_t | send (size_t n, ...) const
ssize_t | recv (size_t n, ...) const
ssize_t | send (const void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Send <n> bytes via Win32 WriteFile using overlapped I/O.
ssize_t | recv (void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Recv <n> bytes via Win32 ReadFile using overlapped I/O.
ssize_t | sendv (const iovec iov[], size_t n) const
| Send an <iovec> of size <n> to the file.
ssize_t | recvv (iovec *io_vec)
ssize_t | sendv_n (const iovec iov[], size_t n) const
| Send an <iovec> of size <n> to the file. Will block until all bytes are sent or an error occurs.
ssize_t | recvv_n (iovec iov[], size_t n) const
| Receive an <iovec> of size <n> to the file.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Friends
class | ACE_FILE_Connector

## Detailed Description

Read/Write operations on Files.

## Member Typedef Documentation

typedef ACE_FILE_Addr ACE_FILE_IO::PEER_ADDR

## Constructor & Destructor Documentation

ACE_FILE_IO::ACE_FILE_IO ( | void )

| Default constructor.

## Member Function Documentation

void ACE_FILE_IO::dump ( | void ) const

| Dump the state of an object. Reimplemented from ACE_FILE.

ssize_t ACE_FILE_IO::recv ( | void * buf,
| size_t n,
| ACE_OVERLAPPED * overlapped ) const

| Recv <n> bytes via Win32 ReadFile using overlapped I/O.

ssize_t ACE_FILE_IO::recv ( | size_t n,
| ... ) const

| This is an interface to readv, that doesn't use the struct iovec explicitly. The ... can be passed as an arbitrary number of (char *ptr, int len) tuples. However, the count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_FILE_IO::recv ( | iovec iov[],
| size_t n ) const

| Recv iovecs via <readv>.

ASYS_INLINE ssize_t ACE_FILE_IO::recv ( | void * buf,
| size_t n ) const

| Recv upto <n> bytes in <buf>.

ASYS_INLINE ssize_t ACE_FILE_IO::recv_n ( | void * buf,
| size_t n ) const

| Recv n bytes, keep trying until n are received.

ssize_t ACE_FILE_IO::recvv ( | iovec * io_vec )

| Allows a client to read from a file without having to provide a buffer to read. This method determines how much data is in the file, allocates a buffer of this size, reads in the data, and returns the number of bytes read. The caller is responsible for deleting the member in the <iov_base> field of <io_vec> using delete [] io_vec->iov_base.

ASYS_INLINE ssize_t ACE_FILE_IO::recvv_n ( | iovec iov[],
| size_t n ) const

| Receive an <iovec> of size <n> to the file.

ssize_t ACE_FILE_IO::send ( | const void * buf,
| size_t n,
| ACE_OVERLAPPED * overlapped ) const

| Send <n> bytes via Win32 WriteFile using overlapped I/O.

ssize_t ACE_FILE_IO::send ( | size_t n,
| ... ) const

| Send N char *ptrs and int lengths. Note that the char *'s precede the ints (basically, an varargs version of writev). The count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_FILE_IO::send ( | const iovec iov[],
| size_t n ) const

| Send iovecs via <writev>.

ASYS_INLINE ssize_t ACE_FILE_IO::send ( | const void * buf,
| size_t n ) const

| send upto <n> bytes in <buf>.

ASYS_INLINE ssize_t ACE_FILE_IO::send_n ( | const ACE_Message_Block * message_block,
| const ACE_Time_Value * timeout = 0,
| size_t * bytes_transferred = 0 )

| Send all the <message_block>s chained through their <next> and <cont> pointers. This call uses the underlying OS gather-write operation to reduce the domain-crossing penalty.

ASYS_INLINE ssize_t ACE_FILE_IO::send_n ( | const void * buf,
| size_t n ) const

| Send n bytes, keep trying until n are sent.

ASYS_INLINE ssize_t ACE_FILE_IO::sendv ( | const iovec iov[],
| size_t n ) const

| Send an <iovec> of size <n> to the file.

ASYS_INLINE ssize_t ACE_FILE_IO::sendv_n ( | const iovec iov[],
| size_t n ) const

| Send an <iovec> of size <n> to the file. Will block until all bytes are sent or an error occurs.

## Friends And Related Function Documentation

class ACE_FILE_Connector`[friend]`

## Member Data Documentation

ACE_FILE_IO::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks. Reimplemented from ACE_FILE.

The documentation for this class was generated from the following files:

- FILE_IO.h
- FILE_IO.cpp
- FILE_IO.i